/* hello.c 
 * 
 * "Hello, world" - the loadable kernel module version. 
 *
 * Compile this with the makefile (type make)
 *
 */

/* Standard headers for LKMs */
#include <linux/module.h>  
/* #include <linux/config.h>  */
#include <linux/init.h>  

#include <linux/tty.h>      /* console_print() interface */
MODULE_LICENSE("GPL");

void console_print(const char *s)
{
    printk(KERN_EMERG "%s", s);
}

/* Initialize the LKM */
static int __init init_hello(void)
{
  console_print("Hello, world - this is the kernel speaking\n");
  /* More normal is printk(), but there's less that can go wrong with 
     console_print(), so let's start simple.
  */

  /* If we return a non zero value, it means that 
   * init_module failed and the LKM can't be loaded 
   */
  return 0;
}


/* Cleanup - undo whatever init_module did */
static void __exit cleanup_hello(void)
{
  console_print("Short is the life of an LKM\n");
}

module_init(init_hello);
module_exit(cleanup_hello);
